<%!
String styleContext = "/HSMEnroll/images/";     // Enroll
String styleShortContext = "images";

public void initStyleContext(HttpServletRequest req)
{
  if (WebAppUtilities.isSelfCare(req)) 
  {                                             // Selfcare
    styleContext = "/HSMSelfcare/html/";
    styleShortContext = "html";
  }
  else if (WebAppUtilities.isCustCare(req))
  {                                             // Custcare
    styleContext = "/HSMcustcare/html/";
    styleShortContext = "html";
  }
}

public String getLocaleStringForStyle(HttpServletRequest req)
{
  String localeString ="";
  localeString =  getLocaleForStyle(req).toString();
  return  localeString;
}

public String getTCPIPAddressForStyle()
{
  try
  {
    return java.net.InetAddress.getLocalHost().getHostAddress();
  }
  catch(java.net.UnknownHostException e)
  {
    return "";
  }
}


public int getPortNumber(HttpServletRequest req)
{
int rtnPortNumber = 80;
PropertyResourceBundle tsmConfig=(PropertyResourceBundle)PropertyResourceBundle.getBundle("HSMCommon");
  if (tsmConfig.getString("ReverseProxyActive").trim().equalsIgnoreCase("true"))
  {
     rtnPortNumber = new Integer(tsmConfig.getString("ReverseProxyServerPort").trim()).intValue();
  }
  else
  {
    rtnPortNumber = new Integer(req.getServerPort()).intValue();
  }

  return  rtnPortNumber;

}


public String getProtocol(HttpServletRequest req)
{
String rtnProtocol = "";
PropertyResourceBundle tsmConfig=(PropertyResourceBundle)PropertyResourceBundle.getBundle("HSMCommon");
  if (tsmConfig.getString("ReverseProxyActive").trim().equalsIgnoreCase("true"))
  {
     rtnProtocol = tsmConfig.getString("ReverseProxyScheme").trim();
  }
  else
  {
    rtnProtocol = req.getScheme();
  }
  return  rtnProtocol;
}

public String getLocaleStyleString(HttpServletRequest req)
{
   String styleLoc = null;
   String protocol = getProtocol(req);
   URL url = null;
   String hostName = getTCPIPAddressForStyle();
   String fileName = "Styles.css";
   String loc = getLocaleStringForStyle(req);
   int portNumber = 80;


   initStyleContext(req);


   portNumber = getPortNumber(req);


      // Try full locale string as subdir
      try
      {
        url = new URL(protocol,hostName,portNumber,styleContext + loc + "/" + fileName);
        styleLoc = url.toString(); 
        //System.out.println("style url is " + url);
      }
      catch(MalformedURLException e)
      {
        // if there is a problem with the URL build the String where the style sheet should be
        // and return the string
        loc = getLangString(req);
        styleLoc = styleShortContext + "/" + loc + "/" + fileName;
        return styleLoc;

       // System.out.println("Exception in getLocaleStyleString():" + e);
      //  styleLoc = protocol + "://" + hostName + styleContext + fileName;            
      }

      // try to connect to help url
      if(!attemptStyleConnection(url))
      {

         // not found ... if locale is longer than 2 chars, try truncating it
         if (loc.length() > 2) {
            String newloc = loc.substring(0,2);      
            try
            {
              url = new URL(protocol,hostName,portNumber,styleContext + newloc.toLowerCase() + "/" + fileName);
              styleLoc = url.toString(); 
               //System.out.println("In getLocaleStyleString() - url is " + url);
            }
            catch(MalformedURLException e)
            {
               //System.out.println("Exception in getLocaleStyleString() creating URL:" + e);
              styleLoc =  styleShortContext + "/" + fileName;            
            }
            // try to connect to url with shortened locale name
            if(!attemptStyleConnection(url))
            {
                // System.out.println("In getLocaleStyleString - could not find lang-specific Style sheet (1)");
                styleLoc =  styleShortContext + "/" + fileName;            
            }
            else
            {
              // System.out.println("In getLocaleStyleString - found short locale lang-specific Style sheet");
              styleLoc = styleShortContext + "/" + newloc + "/" + fileName;
            }
            // System.out.println("In getLocaleStyleString - returning style sheet location string: "+styleLoc);
         }
         else
         {
           // System.out.println("In getLocaleStyleString - could not find lang-specific Style sheet (2)");
           styleLoc = styleShortContext + "/" + fileName;
           // System.out.println("In getLocaleStyleString - returning style sheet location string: "+styleLoc);
         }
      }
      else
      {
        styleLoc = styleShortContext + "/" + loc + "/" + fileName;
        // System.out.println("In getLocaleStyleString() found style sheet at:\n"+styleLoc);
      }
      return styleLoc;
}    

public boolean attemptStyleConnection(URL new_url){

   int response = 0;
   boolean foundStyleSheet = false;
   //System.out.println("In attemptStyleConnection new_URL " + new_url);
   try
   {
	  URLConnection uc = new_url.openConnection();
      String sBody = null;

      if(uc instanceof HttpURLConnection)                     // check for http connection
      {
        response = ((HttpURLConnection) uc).getResponseCode();
         //System.out.println("In getLocaleStyleString() - URL response code " + response );
      }
      // Check the response code
      if(response <200  || response >= 400)
      {
          //System.out.println("In getLocaleStyleString() - Page not found. URL response code "+response );  
      }
      else
      {
         //System.out.println("In getLocaleStyleString() - Page found. URL response code "+response );  
        foundStyleSheet = true;
      }

   }
   catch (Exception e)
   {
      //System.out.println("Exception in getLocaleStyleString() - Style sheet not found. " + e); 
   }
   return foundStyleSheet;
}
public Locale getLocaleForStyle(HttpServletRequest req)
{
  Locale locale;                                         
  String newlang;                                         
  int dash;
  int multiSeperator;
  String lang = req.getHeader("accept-language");
  if (lang == null)
  {
    lang = "en";
  }
  // See if there are multiple browser languages specified
  if ((multiSeperator=lang.indexOf(',')) != -1)
  {
    lang = lang.substring(0, multiSeperator);
  }
                         
  if (lang.length() > 1 && Character.isLetter(lang.charAt(0)) && Character.isLetter(lang.charAt(1)) )
  {
      newlang = lang.substring(0,2);      
  }
  else
  {
     newlang = "en";                     
  }
  if ((dash = lang.indexOf('-')) == -1 )
  {
    locale = new Locale(newlang, "");
  }
  else 
  {
    locale = new Locale(lang.substring(0, dash), lang.substring(dash+1));
  }
  //System.out.println("In getLocaleForStyle locale " + locale);
  return locale;
} 



public String getLangString(HttpServletRequest req)
{
  String newlang;                                         
  int dash;
  int multiSeperator;
  String lang = req.getHeader("accept-language");

  if (lang == null)
  {
    lang = "en";
  }

  // See if there are multiple browser languages specified
  if ((multiSeperator=lang.indexOf(',')) != -1)
  {
    lang = lang.substring(0, multiSeperator);
  }


  if (lang.length() > 2)
  {
      newlang = lang.substring(0,2);      
  }
  else
  {
      newlang = lang;
  }

  boolean supportedLang = false;

  if (newlang.equals("de") ||
      newlang.equals("en") ||
      newlang.equals("es") ||
      newlang.equals("fr") ||
      newlang.equals("it") ||
      newlang.equals("ja") ||
      newlang.equals("ko") ||
      newlang.equals("pt") ||
      newlang.equals("zh") 
     )
  {
    supportedLang = true;
  }

  
  if (newlang.equals("pt"))
  {
      lang = "pt_BR";
  }
  else if (lang.equals("zh-tw"))
  {
      lang = "zh_TW";
  }
  else if (lang.equals("zh-cn"))
  {
      lang = "zh_CN";
  }
  else
  {
      lang = newlang;
  }


  if (!supportedLang)
  {
     lang = "en";
  }

  //System.out.println("In getLangString return lang " + lang);

  return lang;
} 
%>
